﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading;
using System.Windows.Forms;

namespace WinFormsApp1
{
    public partial class Form1 : Form
    {
        List<CanData> dataList = new List<CanData>();
        List<string[]> dataBlockStr = new List<string[]>();

        public string lastFound8200 = "";
        public string lastFound8210 = "";

        Int32 blkPtr;
        Int32 blkJmpCnt;

        bool rollRunning;
        int rollDelay;
        public event EventHandler RollFinishedEvent;
        Thread rollThread;

        System.Timers.Timer convTimer;

        public Form1()
        {
            InitializeComponent();

            rollRunning = false;

            rollDelay = int.Parse(textBox_RollSpeed.Text);

            blkPtr = 0;
            blkJmpCnt = int.Parse(textBox_JmpCnt.Text);

            convTimer = new System.Timers.Timer(1000);
            convTimer.AutoReset = true;
            convTimer.Elapsed += new System.Timers.ElapsedEventHandler(ReadSelected);
            convTimer.Start();
        }

        private void button_OpenFile_Click(object sender, EventArgs e)
        {
            if (openFileDialog.ShowDialog() == DialogResult.OK)
            {
                richTextBox_Data.Text = "Data convert start\n";
                StreamReader reader = new StreamReader(openFileDialog.OpenFile());
                PutDataToList(reader);
                reader.Close();

                BuildBlock dataBlock = new BuildBlock();

                foreach (CanData canTgm in dataList)
                {
                    switch (dataBlock.PutData(canTgm.canRegister_Str, canTgm.canData_Str))
                    {
                        case "Done": // block match
                            dataBlockStr.Add(dataBlock.dataBlkStr);
                            dataBlock = new BuildBlock();
                            break;

                        case "Abnormal":
                            richTextBox_WTF.Text = canTgm.canRegister_Str + " " + canTgm.canData_Str +"\n";
                            break;

                        default: break;
                    }
                }
                richTextBox_Data.Text = "Data convert done\n";
            }
            label_BlkCnt.Text = dataBlockStr.Count.ToString();
        }

        public void ReadSelected(object sender, System.Timers.ElapsedEventArgs e)
        {
            var charsToRemove = new string[] { "(", ")" };
            UInt32 tmp = 0;
            string sTmp = "";

            textBox_4230.Invoke((MethodInvoker)delegate
            {
                if (textBox8.SelectionLength > 0)
                {
                    sTmp = textBox8.SelectedText;

                    foreach (var c in charsToRemove)
                    {
                        sTmp = sTmp.Replace(c, string.Empty);
                    }

                    if(sTmp != "")
                        tmp = UInt32.Parse(sTmp, System.Globalization.NumberStyles.HexNumber);
                }
                textBox_4230.Text = tmp.ToString();
            });

            textBox_4260.Invoke((MethodInvoker)delegate
            {
                if (textBox11.SelectionLength > 0)
                {
                    sTmp = textBox11.SelectedText;

                    foreach (var c in charsToRemove)
                    {
                        sTmp = sTmp.Replace(c, string.Empty);
                    }

                    if (sTmp != "")
                        tmp = UInt32.Parse(sTmp, System.Globalization.NumberStyles.HexNumber);
                }
                textBox_4260.Text = tmp.ToString();
            });
        }

        private void PutDataToList(StreamReader rd)
        {
            string readLine;

            while(rd.EndOfStream == false)
            {
                CanData canData = new CanData();
                string result;

                readLine = rd.ReadLine();

                result = canData.ConvertStingToData(readLine);

                if (result == "ItsAllGoood")
                {
                    dataList.Add(canData);
                }
                else
                {
                    richTextBox_WTF.Text = result + "\n";
                }
            }
        }

        private void button_RollData_Click(object sender, EventArgs e)
        {
            if(rollRunning)
            {
                rollRunning = false;
                button_RollData.Text = "Start Roll";
            }
            else
            {
                rollRunning = true;
                RollFinishedEvent += RollTaskIsDone;
                rollThread = new Thread(new ThreadStart(RollData));
                rollThread.Start();
                button_RollData.Text = "Stop Roll";
            }
        }

        // viser en "blok" af gangen, men kun highlight data der ændre sig?
        public void RollData()
        {
            string[] dataBlk;
            string[] dataBlkOld = new string[100];

            try
            {
                label_BlkCnt.Invoke((MethodInvoker)delegate
                {
                    label_BlkCnt.Text = dataBlockStr.Count.ToString();
                });

                while ((rollRunning == true) && (blkPtr <= dataBlockStr.Count))
                {
                    label_BlkNr.Invoke((MethodInvoker)delegate
                    {
                        label_BlkNr.Text = blkPtr.ToString();
                    });

                    dataBlk = dataBlockStr[blkPtr];

                    if (blkPtr>0)
                    {
                        dataBlkOld = dataBlockStr[blkPtr - 1];
                    }

                    textBox1.Invoke((MethodInvoker)delegate
                    {
                        textBox1.Text = FindChanges(dataBlk[0], dataBlkOld[0]);
                    });

                    textBox2.Invoke((MethodInvoker)delegate
                    {
                        textBox2.Text = FindChanges(dataBlk[1], dataBlkOld[1]);
                    });

                    textBox3.Invoke((MethodInvoker)delegate
                    {
                        textBox3.Text = FindChanges(dataBlk[2], dataBlkOld[2]);
                    });

                    textBox4.Invoke((MethodInvoker)delegate
                    {
                        textBox4.Text = FindChanges(dataBlk[3], dataBlk[15]);
                    });

                    textBox5.Invoke((MethodInvoker)delegate
                    {
                        textBox5.Text = FindChanges(dataBlk[4], dataBlk[16]);
                    });

                    textBox15.Invoke((MethodInvoker)delegate
                    {
                        textBox15.Text = FindChanges(dataBlk[5], dataBlkOld[5]);
                    });

                    textBox6.Invoke((MethodInvoker)delegate
                    {
                        textBox6.Text = FindChanges(dataBlk[6], dataBlkOld[6]);
                    });

                    textBox7.Invoke((MethodInvoker)delegate
                    {
                        textBox7.Text = FindChanges(dataBlk[7], dataBlkOld[7]);
                    });

                    textBox8.Invoke((MethodInvoker)delegate
                    {
                        textBox8.Text = FindChanges(dataBlk[8], dataBlkOld[8]);
                    });

                    textBox9.Invoke((MethodInvoker)delegate
                    {
                        textBox9.Text = FindChanges(dataBlk[9], dataBlkOld[9]);
                    });

                    textBox10.Invoke((MethodInvoker)delegate
                    {
                        textBox10.Text = FindChanges(dataBlk[10], dataBlkOld[10]);
                    });

                    textBox11.Invoke((MethodInvoker)delegate
                    {
                        textBox11.Text = FindChanges(dataBlk[11], dataBlkOld[11]);
                    });

                    textBox12.Invoke((MethodInvoker)delegate
                    {
                        textBox12.Text = FindChanges(dataBlk[12], dataBlkOld[12]);
                    });

                    textBox13.Invoke((MethodInvoker)delegate
                    {
                        textBox13.Text = FindChanges(dataBlk[13], dataBlkOld[13]);
                    });

                    textBox14.Invoke((MethodInvoker)delegate
                    {
                        textBox14.Text = FindChanges(dataBlk[14], dataBlkOld[14]);
                    });

                    blkPtr++;

                    Thread.Sleep(rollDelay);
                }
            }
            catch
            {
                
            }
            finally
            {
                this.BeginInvoke(RollFinishedEvent, EventArgs.Empty);
            }
        }

        private string FindChanges(string newValue, string oldValue)
        {
            string newstring = "";

            if (oldValue == null)
            {
                return newValue;
            }

            if (newValue != null)
            {
                if (newValue.Equals(oldValue))
                {
                    return newValue;
                }
                else
                {
                    for (int i = 0; i < newValue.Length; i++)
                    {
                        if (newValue[i] == oldValue[i])
                        {
                            newstring += newValue[i];
                        }
                        else
                        {
                            newstring += "(" + newValue[i] + ")";
                        }
                    }

                    return newstring;
                }
            }
            else
            {
                return "empty";
            }
        }

        //private string FindChanges(string newValue, string oldValue)
        //{
        //    string newstring = "";

        //    if (oldValue == null)
        //    {
        //        return newValue;
        //    }

        //    if (newValue != null)
        //    {
        //        if (newValue.Equals(oldValue))
        //        {
        //            return newValue;
        //        }
        //        else
        //        {
        //            for (int i = 0; i < newValue.Length; i++)
        //            {
        //                if (newValue[i] == oldValue[i])
        //                {
        //                    newstring += newValue[i];
        //                }
        //                else
        //                {
        //                    newstring += "(" + newValue[i] + "|" + oldValue [i] + ")";
        //                }
        //            }

        //            return newstring;
        //        }
        //    }
        //    else
        //    {
        //        return "empty";
        //    }
        //}

        private void RollTaskIsDone(object sender, EventArgs arg)
        {
            rollRunning = false;
            button_RollData.Text = "Start Roll" + "\n";
            if (arg != EventArgs.Empty)
                richTextBox_WTF.Text = arg.ToString() + "\n";

            richTextBox_Data.Text = "Roll ended" + "\n";
        }

        private void textBox_RollSpeed_KeyUp(object sender, KeyEventArgs e)
        {
            if(e.KeyCode == Keys.Enter)
            {
                if (int.TryParse(textBox_RollSpeed.Text, out int result))
                    rollDelay = result;
                else
                    textBox_RollSpeed.Text = "10";

            }
        }

        private void button_NextBlk_Click(object sender, EventArgs e)
        {
            string[] dataBlk;
            string[] dataBlkOld = new string[100];

            blkPtr += blkJmpCnt;
            if (blkPtr > dataBlockStr.Count)
                blkPtr = 0;

            label_BlkNr.Text = blkPtr.ToString();

            dataBlk = dataBlockStr[blkPtr];

            if (blkPtr > 0)
            {
                dataBlkOld = dataBlockStr[blkPtr - 1];
            }

            textBox1.Invoke((MethodInvoker)delegate
            {
                textBox1.Text = FindChanges(dataBlk[0], dataBlkOld[0]);
            });

            textBox2.Invoke((MethodInvoker)delegate
            {
                textBox2.Text = FindChanges(dataBlk[1], dataBlkOld[1]);
            });

            textBox3.Invoke((MethodInvoker)delegate
            {
                textBox3.Text = FindChanges(dataBlk[2], dataBlkOld[2]);
            });

            textBox4.Invoke((MethodInvoker)delegate
            {
                textBox4.Text = FindChanges(dataBlk[3], dataBlk[15]);
            });

            textBox5.Invoke((MethodInvoker)delegate
            {
                textBox5.Text = FindChanges(dataBlk[4], dataBlk[16]);
            });

            textBox15.Invoke((MethodInvoker)delegate
            {
                textBox15.Text = FindChanges(dataBlk[5], dataBlkOld[5]);
            });

            textBox6.Invoke((MethodInvoker)delegate
            {
                textBox6.Text = FindChanges(dataBlk[6], dataBlkOld[6]);
            });

            textBox7.Invoke((MethodInvoker)delegate
            {
                textBox7.Text = FindChanges(dataBlk[7], dataBlkOld[7]);
            });

            textBox8.Invoke((MethodInvoker)delegate
            {
                textBox8.Text = FindChanges(dataBlk[8], dataBlkOld[8]);
            });

            textBox9.Invoke((MethodInvoker)delegate
            {
                textBox9.Text = FindChanges(dataBlk[9], dataBlkOld[9]);
            });

            textBox10.Invoke((MethodInvoker)delegate
            {
                textBox10.Text = FindChanges(dataBlk[10], dataBlkOld[10]);
            });

            textBox11.Invoke((MethodInvoker)delegate
            {
                textBox11.Text = FindChanges(dataBlk[11], dataBlkOld[11]);
            });

            textBox12.Invoke((MethodInvoker)delegate
            {
                textBox12.Text = FindChanges(dataBlk[12], dataBlkOld[12]);
            });

            textBox13.Invoke((MethodInvoker)delegate
            {
                textBox13.Text = FindChanges(dataBlk[13], dataBlkOld[13]);
            });

            textBox14.Invoke((MethodInvoker)delegate
            {
                textBox14.Text = FindChanges(dataBlk[14], dataBlkOld[14]);
            });
        }

        private void button_Reset_Click(object sender, EventArgs e)
        {
            blkPtr = 0;
        }
    }

    // check if data fit in block
    public class BuildBlock
    {
        UInt16 blockPtr;
        public Int32[] cmpRegs { get; }
        public Byte[,] dataBlock;
        public string[] cmpRegsStr;
        public string[] dataBlkStr;


        // block example?
        //00:42:38:0500 Rx 1 0x4200 x 8 02 00 00 00 00 00 00 D2 
        //00:42:38:0510 Rx 1 0x7310 x 8 01 00 10 02 04 05 34 0C 
        //00:42:38:0510 Rx 1 0x7320 x 8 2D 00 03 0F 90 00 32 00 
        //00:42:38:5500 Rx 1 0x8200 x 8 AA 00 00 00 00 00 00 00  <----

        //00:42:39:0500 Rx 1 0x4200 x 8 00 00 00 00 00 00 00 D2 
        //00:42:39:0510 Rx 1 0x4210 x 8 D9 05 30 75 5A 05 62 64 
        //00:42:39:0510 Rx 1 0x4220 x 8 54 06 5C 05 30 75 36 74 
        //00:42:39:0510 Rx 1 0x4230 x 8 02 0D FC 0C 05 00 0F 00 
        //00:42:39:0510 Rx 1 0x4240 x 8 00 05 E2 04 1E 00 05 00 
        //00:42:39:0520 Rx 1 0x4250 x 8 03 12 00 00 00 00 00 00 
        //00:42:39:0520 Rx 1 0x4260 x 8 0A C3 F9 C2 00 00 01 00 
        //00:42:39:0520 Rx 1 0x4270 x 8 3C 05 28 05 02 00 00 00 
        //00:42:39:0530 Rx 1 0x4280 x 8 AA 00 00 00 00 00 00 00 
        //00:42:39:0530 Rx 1 0x4290 x 8 00 00 00 00 00 00 00 00

        //00:00:00:0000 Rx 1 0x4200 x 8 02 00 00 00 00 00 00 E8 
        //00:00:00:0000 Rx 1 0x7310 x 8 01 00 10 02 04 05 34 0C 
        //00:00:00:0000 Rx 1 0x7320 x 8 2D 00 03 0F 90 00 32 00 
        //00:00:00:0000 Rx 1 0x8210 x 8 AA 00 00 00 00 00 00 00  <----

        //00:00:00:0000 Rx 1 0x4200 x 8 00 00 00 00 00 00 00 E8 
        //00:00:00:0000 Rx 1 0x4210 x 8 D9 05 30 75 50 05 62 64 
        //00:00:00:0000 Rx 1 0x4220 x 8 54 06 5C 05 30 75 36 74 
        //00:00:00:0000 Rx 1 0x4230 x 8 02 0D FC 0C 01 00 0E 00 
        //00:00:00:0000 Rx 1 0x4240 x 8 F6 04 D8 04 23 00 00 00 
        //00:00:00:0000 Rx 1 0x4250 x 8 03 12 00 00 00 00 00 00 
        //00:00:00:0000 Rx 1 0x4260 x 8 07 C3 FD C2 00 00 01 00 
        //00:00:00:0000 Rx 1 0x4270 x 8 28 05 14 05 02 00 00 00 
        //00:00:00:0000 Rx 1 0x4280 x 8 AA 00 00 00 00 00 00 00 
        //00:00:00:0000 Rx 1 0x4290 x 8 00 00 00 00 00 00 00 00

        public BuildBlock()
        {

            blockPtr = 0;
            cmpRegs = new Int32[15];
            dataBlock = new Byte[15,8];
            cmpRegsStr = new string[15];
            dataBlkStr = new string[17];

            cmpRegs[0] = 4200;
            cmpRegs[1] = 7310;
            cmpRegs[2] = 7320;

            cmpRegs[3] = 8200;
            cmpRegs[4] = 8210; // kommer hver anden gang

            cmpRegs[5] = 4200;
            cmpRegs[6] = 4210;
            cmpRegs[7] = 4220;
            cmpRegs[8] = 4230;
            cmpRegs[9] = 4240;
            cmpRegs[0] = 4250;
            cmpRegs[11] = 4260;
            cmpRegs[12] = 4270;
            cmpRegs[13] = 4280;
            cmpRegs[14] = 4290;

            cmpRegsStr[0] = "0x4200";
            cmpRegsStr[1] = "0x7310";
            cmpRegsStr[2] = "0x7320";

            cmpRegsStr[3] = "0x8200";
            cmpRegsStr[4] = "0x8210"; // kommer hver anden gang

            cmpRegsStr[5] = "0x4200";
            cmpRegsStr[6] = "0x4210";
            cmpRegsStr[7] = "0x4220";
            cmpRegsStr[8] = "0x4230";
            cmpRegsStr[9] = "0x4240";
            cmpRegsStr[10] = "0x4250";
            cmpRegsStr[11] = "0x4260";
            cmpRegsStr[12] = "0x4270";
            cmpRegsStr[13] = "0x4280";
            cmpRegsStr[14] = "0x4290";
        }

        public string PutData(Int32 canReg, Byte[] canData)
        {
            Int16 ptr = 0;

            if((cmpRegs[blockPtr] == canReg))
            {
                // copy data
                foreach(Byte data in canData)
                {
                    dataBlock[blockPtr, ptr++] = data;
                }
                blockPtr++;
            }
            else if((cmpRegs[blockPtr + 1] == canReg))
            {
                blockPtr++;
                foreach (Byte data in canData)
                {
                    dataBlock[blockPtr, ptr++] = data;
                }
                blockPtr++;
            }
            else // abnormal block
            {
                blockPtr = 0;
                return "Abnormal";
            }

            if (blockPtr >= cmpRegs.Length)
            {
                blockPtr = 0;
                return "Done";
            }

            return "Ok";
        }

        public string PutData(string canReg, string canDataStr) // det kan oli godt lave smartere, go oli go oli go oli ;)
        {


            if (canReg == "0x8210" )
            {
                blockPtr++;
                dataBlkStr[16] = canDataStr;
            }

            if (cmpRegsStr[blockPtr] == canReg)
            {
                dataBlkStr[blockPtr++] = canDataStr;

                if (canReg == "0x8200")
                {
                    blockPtr++;
                    dataBlkStr[15] = canDataStr;
                }
            }
            else // abnormal block
            {
                blockPtr = 0;
                return "Abnormal";
            }

            if (blockPtr >= cmpRegs.Length )
            {
                blockPtr = 0;
                return "Done";
            }



            return "Ok";
        }
    }

    // Convert strings to data
    public class CanData
    {
        public string timeStamp { get; set; }
        public Int32 canRegister { get; set; }
        public Byte[] canData { get; set; }
        public string canRegister_Str { get; set; }
        public string canData_Str { get; set; }

        public CanData()
        {
            timeStamp = "";
            canRegister = -1;
            canData = new Byte[8];
            canRegister_Str = "";
            canData_Str = "";
        }

        public string ConvertStingToData(string input)
        {
            string[] splitStrs;
            if (input.Contains("*") == false) // discard if useless data
            {
                splitStrs = input.Split(" ");

                if (splitStrs.Length == 15)
                {
                    timeStamp = splitStrs[0]; // Timestamp

                    if (Int32.TryParse(splitStrs[3].Substring(2), out Int32 val))
                    {
                        canRegister = val;
                    }
                    canRegister_Str = splitStrs[3];

                    canData = StringToByteArray(splitStrs[6] + splitStrs[7] + splitStrs[8] + splitStrs[9] + splitStrs[10] + splitStrs[11] + splitStrs[12] + splitStrs[13]);
                    canData_Str = splitStrs[6] + splitStrs[7] + splitStrs[8] + splitStrs[9] + splitStrs[10] + splitStrs[11] + splitStrs[12] + splitStrs[13];

                    return "ItsAllGoood"; // <---- Its Good
                }
            }
            return input; // WTF data! means its shit
        }

        public static byte[] StringToByteArray(string hex)
        {
            return Enumerable.Range(0, hex.Length)
                             .Where(x => x % 2 == 0)
                             .Select(x => Convert.ToByte(hex.Substring(x, 2), 16))
                             .ToArray();
        }
    }
}
